## digikam 5.3.0

=== core/CMakeLists.txt ===
#
# Copyright (c) 2010-2016 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# Copyright (c) 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
# Copyright (c) 2015      by Mohamed Anwer, <m dot anwer at gmx dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

project(digikam)

message(STATUS "----------------------------------------------------------------------------------")
message(STATUS "Starting CMake configuration for: ${PROJECT_NAME}")

# ==================================================================================================
# Information to update before to release this package.

# digiKam version
set(DIGIKAM_MAJOR_VERSION "5")
set(DIGIKAM_MINOR_VERSION "3")
set(DIGIKAM_PATCH_VERSION "0")

#digiKam release date
set(DIGIKAM_RELEASE_DATE "2016-11-06")

# Suffix to add at end of version string. Usual values are:
# "-git"   : alpha code unstable from git. Do not use in production
# "-beta1" : beta1 release.
# "-beta2" : beta2 release.
# "-beta3" : beta3 release.
# "-rc"    : release candidate.
# ""       : final release. Can be used in production.
set(DIGIKAM_SUFFIX_VERSION "")

# ==================================================================================================
# Set env. variables accordingly.

# NOTE: This string is used to set libdigikamcore and libdigikamdatabase SO version ID
set(DIGIKAM_VERSION_SHORT
    "${DIGIKAM_MAJOR_VERSION}.${DIGIKAM_MINOR_VERSION}.${DIGIKAM_PATCH_VERSION}"
)

set(DIGIKAM_VERSION_STRING
    "${DIGIKAM_VERSION_SHORT}${DIGIKAM_SUFFIX_VERSION}"
)

# Core Database XML version
# We must set this variable here at top level because it is used in both libs/database/core and data/database
# Version history:
# 1 : Original database XML file, published in production.
# 2 : 08-08-2014 : Fix Images.names field size (see bug #327646).
# 3 : 05/11/2015 : Add Face DB schema.
set(DBCORECONFIG_XML_VERSION "3")

# =======================================================

set(CMAKE_MIN_VERSION    "3.0.0")
set(ECM_MIN_VERSION      "1.7.0")
set(KF5_MIN_VERSION      "5.1.0")
set(QT_MIN_VERSION       "5.2.0")
set(KIPI_MIN_VERSION     "5.0.0")
set(KSANE_MIN_VERSION    "5.0.0")
set(LENSFUN_MIN_VERSION  "0.2.6.0")
set(EXIV2_MIN_VERSION    "0.25")
set(AKONADI_MIN_VERSION  "4.89.0")        # Akonadi Contact dependency
set(CALENDAR_MIN_VERSION "4.81.0")        # Calendar Core dependency

cmake_minimum_required(VERSION ${CMAKE_MIN_VERSION})

############## ECM setup ######################

find_package(ECM ${ECM_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${digikam_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

# Cmake macros
include(GenerateExportHeader)
include(CheckFunctionExists)
include(FeatureSummary)
# ECM macros
include(ECMOptionalAddSubdirectory)
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)
include(ECMPackageConfigHelpers)
include(ECMSetupVersion)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMPoQmTools)
# KDE macros
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEFrameworkCompilerSettings)
include(KDECompilerSettings)
# Local macros
include(MacroUtils)
include(MacroLocalLibs)
include(MacroOpenCV)
include(MacroJPEG)
include(MacroBoolTo01)

# ==================================================================================================

option(ENABLE_OPENCV3               "Build digiKam with OpenCV3 instead OpenCV2 (default=OFF)"                           OFF)
option(ENABLE_KFILEMETADATASUPPORT  "Build digiKam with KDE files indexer support (default=OFF)"                         OFF)
option(ENABLE_AKONADICONTACTSUPPORT "Build digiKam with KDE Mail Contacts support (default=OFF)"                         OFF)
option(ENABLE_MEDIAPLAYER           "Build digiKam with QtMultimedia support (default=OFF)"                              OFF)
option(ENABLE_DBUS                  "Build digiKam with DBUS support (default=ON)"                                       ON)
option(ENABLE_APPSTYLES             "Build digiKam with support for changing the widget application style (default=OFF)" OFF)

# Mysql support options (experimental):
option(ENABLE_MYSQLSUPPORT          "Build digiKam with MySQL dabatase support (default=OFF)"                            OFF)
option(ENABLE_INTERNALMYSQL         "Build digiKam with internal MySQL server executable (default=OFF)"                  OFF)


# Debug options:
option(ENABLE_DIGIKAM_MODELTEST     "Enable ModelTest on some models for debugging (default=OFF)"                        OFF)

############## Find Packages ###################

find_package(Qt5 ${QT_MIN_VERSION}
             REQUIRED NO_MODULE COMPONENTS
             Core
             Concurrent
             Widgets
             Gui
             Sql
             Xml
             PrintSupport
             WebKitWidgets
             Network
)

find_package(Qt5 ${QT_MIN_VERSION}
             OPTIONAL_COMPONENTS
             Multimedia
             MultimediaWidgets
             DBus
             OpenGL
)

if(ENABLE_MEDIAPLAYER)
    if(NOT Qt5Multimedia_FOUND OR NOT Qt5MultimediaWidgets_FOUND)
        set(ENABLE_MEDIAPLAYER OFF)
    endif()
endif()

if(ENABLE_DBUS)
    if(NOT Qt5DBus_FOUND)
        set(ENABLE_DBUS OFF)
    endif()
endif()

if(BUILD_TESTING)
    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS
                 Test)
endif()

find_package(KF5 ${KF5_MIN_VERSION}
             REQUIRED COMPONENTS
             XmlGui
             CoreAddons
             Config
             Service
             WindowSystem
             Solid
             I18n
)

find_package(KF5 ${KF5_MIN_VERSION}
             OPTIONAL_COMPONENTS
             KIO                    # For Desktop integration (Widgets only).
             IconThemes             # For Desktop integration.
             Bookmarks              # For geolocation editor.
             FileMetaData           # For KDE file indexer support.
             ThreadWeaver           # For Panorama tool.
             NotifyConfig           # KDE desktop application notify configuration.
             Notifications          # KDE desktop notifications integration.
)

find_package(KF5 ${AKONADI_MIN_VERSION}
             OPTIONAL_COMPONENTS
             AkonadiContact         # For KDE Mail Contacts support.
)

find_package(KF5 ${CALENDAR_MIN_VERSION}
             OPTIONAL_COMPONENTS
             CalendarCore           # For Calendar tool.
)

if(ENABLE_AKONADICONTACTSUPPORT AND NOT KF5AkonadiContact_FOUND)
    set(ENABLE_KFILEMETADATASUPPORT OFF)
endif()

if(ENABLE_KFILEMETADATASUPPORT AND NOT KF5FileMetaData_FOUND)
    set(ENABLE_KFILEMETADATASUPPORT OFF)
endif()

# Check if KIO have been compiled with KIOWidgets. digiKam only needs this one.
if(KF5KIO_FOUND)
    get_target_property(KIOWidgets_INCLUDE_DIRS KF5::KIOWidgets INTERFACE_INCLUDE_DIRECTORIES)
    message(STATUS "KF5::KIOWidgets include dirs: ${KIOWidgets_INCLUDE_DIRS}")

    if(NOT KIOWidgets_INCLUDE_DIRS)
        message(STATUS "KF5::KIOWidgets not available in shared KIO library. KIO support disabled.")
        set(KF5KIO_FOUND FALSE)
    endif()
endif()

# ==================================================================================================
# Dependencies Rules

# mandatory

DETECT_JPEG()
set(DIGIKAM_LIBJPEG_DIR libjpeg-${JPEG_LIB_VERSION})

find_package(TIFF                       REQUIRED)
find_package(PNG                        REQUIRED)
find_package(Boost                      REQUIRED)
find_package(LCMS2                      REQUIRED)
find_package(EXPAT                      REQUIRED)  # For DNGWriter: XMP SDK need Expat library to compile.
find_package(Threads                    REQUIRED)  # For DNGWriter and LibRaw which needs native threads support.
find_package(Exiv2 ${EXIV2_MIN_VERSION} REQUIRED)

set_package_properties("Exiv2"     PROPERTIES
                       DESCRIPTION "Required to build digiKam"
                       URL         "http://www.exiv2.org"
                       TYPE        RECOMMENDED
                       PURPOSE     "Library to manage image metadata"
)

# -- check OpenCV --------------------------------------------------------------------------------

if(ENABLE_OPENCV3)

    set(OPENCV_MIN_VERSION "3.1.0")
    DETECT_OPENCV(${OPENCV_MIN_VERSION} core highgui objdetect imgproc)

    if(${OpenCV_FOUND})
        if(${OpenCV_VERSION} VERSION_LESS 3.1.0)
            message(STATUS "ENABLE_OPENCV3 option is enabled and OpenCV < 3.1.0 have been found. Disabled ENABLE_OPENCV3")
            set(OpenCV_FOUND FALSE)
        endif()
    endif()

else()

    set(OPENCV_MIN_VERSION "2.4.9")
    DETECT_OPENCV(${OPENCV_MIN_VERSION} core highgui objdetect contrib legacy imgproc)

    if(${OpenCV_FOUND})
        if(${OpenCV_VERSION} VERSION_GREATER 2.4.99)
            message(STATUS "ENABLE_OPENCV3 option is disabled and OpenCV >= 3.0.0 have been found. Enabled ENABLE_OPENCV3")
            set(OpenCV_FOUND FALSE)
        endif()
    endif()

endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/app/utils/libopencv.h.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/app/utils/libopencv.h)

# -- optionals ----------------------------------------------------------------------------------

find_package(FLEX)                                 # For Panorama tool.
find_package(BISON)                                # For Panorama tool.

DETECT_LIBKIPI(${KIPI_MIN_VERSION})
DETECT_LIBKSANE(${KSANE_MIN_VERSION})

find_package(Marble)

find_package(PkgConfig)
find_package(Jasper)
find_package(Eigen3)                               # For Refocus tool.
find_package(OpenGL)                               # For Presentation tool.

# For Monitor Profiles management with LCMS
find_package(X11)

if(X11_FOUND)
    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS
                 X11Extras
    )
    set(HAVE_X11 TRUE)
else()
    set(HAVE_X11 FALSE)
endif()

# decide if Presentation tool can be built with OpenGL
if(OPENGL_FOUND AND OPENGL_GLU_FOUND AND Qt5OpenGL_FOUND)
    set(HAVE_OPENGL TRUE)
elseif()
    set(HAVE_OPENGL FALSE)
endif()

# For LibRaw
if(WIN32)
    find_library(WSOCK32_LIBRARY wsock32)
    find_library(WS2_32_LIBRARY ws2_32)
endif()

# -- To link under Solaris (see bug #274484) ------------------------------------------------------

if(NOT WIN32)
    find_library(MATH_LIBRARY m)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
    find_library(KVM_LIBRARY kvm)
endif()

# ==================================================================================================
# More Optional Dependencies

find_package(Doxygen)
find_package(Lqr-1)

# -- libgphoto2 rules --------------------------------------------------------------------------

if(NOT WIN32)

    find_package(Gphoto2)

    if(GPHOTO2_FOUND)

        if("${GPHOTO2_VERSION_STRING}" VERSION_GREATER "2.4.0")
            set(VERSION_GPHOTO2 true)
        else()
            set(VERSION_GPHOTO2 false)
        endif()

        if("${GPHOTO2_VERSION_STRING}" VERSION_GREATER "2.5.0")
            set(VERSION_GPHOTO25 true)
            message(STATUS "libgphoto2 API version >= 2.5")
        else()
            set(VERSION_GPHOTO25 false)
            message(STATUS "libgphoto2 API version < 2.5")
        endif()

        if(VERSION_GPHOTO25)
            set(HAVE_GPHOTO25 1)
        else()
            set(HAVE_GPHOTO25 0)
        endif()

    endif()

endif()

# -- Check LensFun library for Lens auto-correction tool --------------------------------------

find_package(LensFun)

if(LENSFUN_VERSION)
    message(STATUS "liblensfun: Found version ${LENSFUN_VERSION} (required: ${LENSFUN_MIN_VERSION})")
    if(${LENSFUN_VERSION} VERSION_LESS ${LENSFUN_MIN_VERSION})
        set(LENSFUN_FOUND FALSE)
    endif()
else()
    message(STATUS "liblensfun: Version information not found, your version is probably too old.")
    set(LENSFUN_FOUND FALSE)
endif()

=== doc-translated/CMakeLists.txt ===
add_subdirectory( nl )
add_subdirectory( uk )

=== core/app/CMakeLists.txt ===
#
# Copyright (c) 2010-2016 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# Copyright (c) 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

if (POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif (POLICY CMP0063)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/utils/digikam_version.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/utils/digikam_version.h)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/utils/digikam_dbconfig.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/utils/digikam_dbconfig.h)

# digikam core
set(DIGIKAMCORE_OBJECTS
            $<TARGET_OBJECTS:digikamdatabasecore_src>
            $<TARGET_OBJECTS:dimg_src>
            $<TARGET_OBJECTS:dmetadata_src>
            $<TARGET_OBJECTS:jpegutils_src>
            $<TARGET_OBJECTS:progressmanager_src>
            $<TARGET_OBJECTS:threadimageio_src>
            $<TARGET_OBJECTS:pgfutils_src>
            $<TARGET_OBJECTS:dthread_src>
            $<TARGET_OBJECTS:versionmanager_src>
            $<TARGET_OBJECTS:kmemoryinfo_src>
            $<TARGET_OBJECTS:dngwriter_src>
            $<TARGET_OBJECTS:rawengine_srcs>
            $<TARGET_OBJECTS:digikamfacesengine_src>

            # widgets
            $<TARGET_OBJECTS:digikamwidgetscore_src>
            $<TARGET_OBJECTS:digikamdialogscore_src>
            $<TARGET_OBJECTS:imageproperties_src>
            $<TARGET_OBJECTS:digikamgenericmodels_src>
            $<TARGET_OBJECTS:notificationmanager_src>

            # utilities
            $<TARGET_OBJECTS:slideshow_src>
            $<TARGET_OBJECTS:imageeditor_src>
            $<TARGET_OBJECTS:metadataedit_src>
            $<TARGET_OBJECTS:expoblending_src>
            $<TARGET_OBJECTS:assistants_src>
            $<TARGET_OBJECTS:presentation_src>
            $<TARGET_OBJECTS:akonadiiface_src>  # NOTE: even if optional this code need to be compiled here.
            $<TARGET_OBJECTS:calendar_src>

            utils/digikam_debug.cpp
)

if(MARBLE_FOUND)
    set(DIGIKAMCORE_OBJECTS
        ${DIGIKAMCORE_OBJECTS}
        $<TARGET_OBJECTS:geoiface_src>
        $<TARGET_OBJECTS:geomapwrapper_src>
        $<TARGET_OBJECTS:geolocationedit_src>
    )
endif()

if(KF5Sane_FOUND)
    set(DIGIKAMCORE_OBJECTS
        ${DIGIKAMCORE_OBJECTS}
        $<TARGET_OBJECTS:ksaneiface_src>
    )
endif()

if(FLEX_FOUND AND BISON_FOUND AND KF5ThreadWeaver_FOUND)
    set(DIGIKAMCORE_OBJECTS
        ${DIGIKAMCORE_OBJECTS}
        $<TARGET_OBJECTS:panorama_src>
    )
endif()

include_directories($<TARGET_PROPERTY:Qt5::WebKitWidgets,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Gui,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Xml,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Widgets,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Sql,INTERFACE_INCLUDE_DIRECTORIES>

                    $<TARGET_PROPERTY:KF5::I18n,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::Solid,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::CoreAddons,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::WindowSystem,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::XmlGui,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::Service,INTERFACE_INCLUDE_DIRECTORIES>)

if(KF5KIO_FOUND)
    include_directories($<TARGET_PROPERTY:KF5::KIOWidgets,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

if(ENABLE_MEDIAPLAYER)
    include_directories($<TARGET_PROPERTY:Qt5::Multimedia,INTERFACE_INCLUDE_DIRECTORIES>
                        $<TARGET_PROPERTY:Qt5::MultimediaWidgets,INTERFACE_INCLUDE_DIRECTORIES>
    )
endif()

if(HAVE_OPENGL)
    include_directories($<TARGET_PROPERTY:Qt5::OpenGL,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

if(KF5Kipi_FOUND)
    include_directories($<TARGET_PROPERTY:KF5::Kipi,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

if(GPHOTO2_FOUND)
    include_directories(${GPHOTO2_INCLUDE_DIRS})
endif()

add_library(digikamcore
            SHARED
            ${DIGIKAMCORE_OBJECTS}
)

add_dependencies(digikamcore digikam-gitversion)

generate_export_header(digikamcore BASE_NAME digikam EXPORT_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/utils/digikam_core_export.h")

target_link_libraries(digikamcore
                      PUBLIC

                      Qt5::Core
                      Qt5::Gui
                      Qt5::Xml
                      Qt5::Widgets
                      Qt5::Sql
                      Qt5::WebKitWidgets
                      Qt5::PrintSupport
                      Qt5::Concurrent

                      KF5::Solid
                      KF5::WindowSystem
                      KF5::ConfigGui
                      KF5::CoreAddons
                      KF5::Service
                      KF5::XmlGui
                      KF5::I18n

                      # Required by CImg which use pthread internally.

                      ${CMAKE_THREAD_LIBS_INIT}

                      ${LCMS2_LIBRARIES} # filters

                      ${TIFF_LIBRARIES}
                      ${PNG_LIBRARIES}
                      ${EXIV2_LIBRARIES}

                      libdng
                      libraw
)

if(ENABLE_DBUS)
    target_link_libraries(digikamcore PUBLIC Qt5::DBus)
endif()

if(KF5IconThemes_FOUND)
    target_link_libraries(digikamcore PUBLIC KF5::IconThemes)
endif()

if(KF5KIO_FOUND)
    target_link_libraries(digikamcore PUBLIC KF5::KIOWidgets)
endif()

if(KF5Kipi_FOUND)
    target_link_libraries(digikamcore PUBLIC KF5::Kipi)
endif()

if(KF5Notifications_FOUND)
    target_link_libraries(digikamcore PUBLIC KF5::Notifications)
endif()

if(KF5NotifyConfig_FOUND)
    target_link_libraries(digikamcore PUBLIC KF5::NotifyConfig)
endif()

if(MARBLE_FOUND)
    target_link_libraries(digikamcore PUBLIC ${MARBLE_LIBRARIES})

    if(KF5Bookmarks_FOUND)
        target_link_libraries(digikamcore PRIVATE KF5::Bookmarks)
    endif()
endif()

if(X11_FOUND)
    target_link_libraries(digikamcore PUBLIC Qt5::X11Extras ${X11_LIBRARIES})
endif()

if(JASPER_FOUND)
    target_link_libraries(digikamcore PUBLIC ${JASPER_LIBRARIES})
endif()

# LibLqr-1 library rules for content-aware filter
if(LQR-1_FOUND)
    target_link_libraries(digikamcore PRIVATE ${LQR-1_LIBRARIES})
endif()

if(LENSFUN_FOUND)
    target_include_directories(digikamcore PUBLIC ${LENSFUN_INCLUDE_DIRS})
    target_link_libraries(digikamcore PUBLIC ${LENSFUN_LIBRARIES})
endif()

# for nrfilter
if(OpenCV_FOUND)
    target_link_libraries(digikamcore PRIVATE ${OpenCV_LIBRARIES})
endif()

if(KF5FileMetaData_FOUND)
    target_link_libraries(digikamcore PUBLIC baloowrap)
endif()

if(ENABLE_MEDIAPLAYER)
    target_link_libraries(digikamcore PUBLIC Qt5::Multimedia Qt5::MultimediaWidgets)
endif()

if(HAVE_OPENGL)
    target_link_libraries(digikamcore
                          PUBLIC
                          Qt5::OpenGL
                          ${OPENGL_LIBRARIES}
    )
endif()

if(KF5Sane_FOUND)
    target_link_libraries(digikamcore PUBLIC KF5::Sane)
endif()

if(KF5AkonadiContact_FOUND)
    target_link_libraries(digikamcore PUBLIC KF5::AkonadiContact)
endif()

if(KF5CalendarCore_FOUND)
    target_link_libraries(digikamcore PUBLIC KF5::CalendarCore)
endif()

if(FLEX_FOUND AND BISON_FOUND AND KF5ThreadWeaver_FOUND)
    target_link_libraries(digikamcore PUBLIC KF5::ThreadWeaver)
endif()

if(APPLE)
    target_link_libraries(digikamcore PUBLIC /System/Library/Frameworks/AppKit.framework)
endif()

if(WIN32)
  target_link_libraries(digikamcore PUBLIC wsock32 ws2_32)
endif()

set_target_properties(digikamcore PROPERTIES VERSION ${DIGIKAM_VERSION_SHORT} SOVERSION ${DIGIKAM_VERSION_SHORT})

install(TARGETS digikamcore ${INSTALL_TARGETS_DEFAULT_ARGS})

########################## digiKam GUI sources #############################

if(ENABLE_DBUS)
    qt5_add_dbus_adaptor(digikamadaptor_SRCS main/org.kde.digikam.xml main/digikamapp.h Digikam::DigikamApp)
endif()

set(libdigikamgui_SRCS
    main/digikamapp.cpp

    date/dpopupframe.cpp
    date/ddateedit.cpp
    date/ddatetable.cpp
    date/ddatetable_p.cpp
    date/ddatepicker.cpp
    date/ddatepicker_p.cpp
    date/ddatetimeedit.cpp
    date/ddatepickerpopup.cpp
    date/datefolderview.cpp
    date/monthwidget.cpp
    date/timelinewidget.cpp

    dragdrop/importdragdrop.cpp
    dragdrop/albumdragdrop.cpp
    dragdrop/ddragobjects.cpp
    dragdrop/imagedragdrop.cpp
    dragdrop/tagdragdrop.cpp

    filters/filtersidebarwidget.cpp
    filters/tagfilterview.cpp

    items/digikamimageview.cpp
    items/digikamimageview_p.cpp
    items/digikamimagedelegate.cpp
    items/imagecategorizedview.cpp
    items/imagecategorydrawer.cpp
    items/imagedelegate.cpp
    items/imagethumbnailbar.cpp
    items/imagethumbnaildelegate.cpp
    items/imageviewutilities.cpp
    items/digikamimagefacedelegate.cpp
    items/overlays/assignnameoverlay.cpp
    items/overlays/facerejectionoverlay.cpp
    items/overlays/groupindicatoroverlay.cpp
    items/overlays/imagefsoverlay.cpp
    items/overlays/imageratingoverlay.cpp
    items/overlays/imagerotationoverlay.cpp
    items/overlays/imagecoordinatesoverlay.cpp
    items/overlays/imageselectionoverlay.cpp

    utils/contextmenuhelper.cpp
    utils/tooltipfiller.cpp
    utils/searchmodificationhelper.cpp
    utils/editablesearchtreeview.cpp
    utils/sidebarwidget.cpp
    utils/slideshowbuilder.cpp
    utils/digikammodelcollection.cpp
    utils/digikam_debug.cpp
    utils/componentsinfo.cpp

    views/tableview/tableview.cpp
    views/tableview/tableview_treeview.cpp
    views/tableview/tableview_treeview_delegate.cpp
    views/tableview/tableview_column_configuration_dialog.cpp
    views/tableview/tableview_model.cpp
    views/tableview/tableview_columns.cpp
    views/tableview/tableview_column_audiovideo.cpp
    views/tableview/tableview_column_file.cpp
    views/tableview/tableview_column_geo.cpp
    views/tableview/tableview_column_digikam.cpp
    views/tableview/tableview_column_item.cpp
    views/tableview/tableview_column_photo.cpp
    views/tableview/tableview_column_thumbnail.cpp
    views/tableview/tableview_columnfactory.cpp
    views/tableview/tableview_selection_model_syncer.cpp

    views/imagepreviewviewitem.cpp
    views/imagepreviewview.cpp
    views/welcomepageview.cpp
    views/leftsidebarwidgets.cpp
    views/digikamview.cpp
    views/trashview.cpp
    views/stackedview.cpp

    ${digikamadaptor_SRCS}
)

if(ENABLE_MEDIAPLAYER)
    set(libdigikamgui_SRCS
        ${libdigikamgui_SRCS}
        views/mediaplayerview.cpp
       )
endif()

if(${MARBLE_FOUND})
    set(libdigikamgui_SRCS
        ${libdigikamgui_SRCS}
        views/mapwidgetview.cpp
       )
endif()


add_library(digikamgui_src
            OBJECT
            ${libdigikamgui_SRCS}
)


######################### digiKam GUI objects ############################


set(DIGIKAM_OBJECTS
            $<TARGET_OBJECTS:digikamdatabasemain_src>
            $<TARGET_OBJECTS:digikamfacesenginedatabase_src>
            $<TARGET_OBJECTS:digikamgui_src>
            $<TARGET_OBJECTS:digikamdeletedialog_src>
            $<TARGET_OBJECTS:digikamtemplate_src>
            $<TARGET_OBJECTS:imagepropertiesdigikam_src>
            $<TARGET_OBJECTS:setup_src>
            $<TARGET_OBJECTS:lighttable_src>
            $<TARGET_OBJECTS:maintenance_src>
            $<TARGET_OBJECTS:searchwindow_src>
            $<TARGET_OBJECTS:digikammodels_src>
            $<TARGET_OBJECTS:digikamalbum_src>
            $<TARGET_OBJECTS:firstrun_src>
            $<TARGET_OBJECTS:fuzzysearch_src>
            $<TARGET_OBJECTS:imageeditorgui_src>
            $<TARGET_OBJECTS:fileactionmanager_src>
            $<TARGET_OBJECTS:digikamtags_src>

=== core/libs/CMakeLists.txt ===
#
# Copyright (c) 2010-2016 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

# Common DNG SDK definitions for DNGWriter and RAWEngine.

# Set platteforms flags.
# NOTE: see bug #195735: do not enable Mac flags provided by Adobe.
#       Sounds like all compile fine like under Linux.

if(MSVC)
    add_definitions(
                    # XMP SDK
                    -DWIN_ENV=1

                    # DNG SDK
                    -DqWinOS=1
                    -DqMacOS=0
                    -DqDNGUseStdInt=0
                    )
else()
    add_definitions(
                     # XMP SDK
                    -DUNIX_ENV=1

                    # DNG SDK
                    -DqWinOS=0
                    -DqMacOS=0
                    -DqDNGUseStdInt=1
                   )
endif()

# Check processor endianness
include(TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)

if(NOT IS_BIG_ENDIAN)
    add_definitions(-DqDNGLittleEndian=1)
endif()

# Thread safe support under Mac and Linux using pthread library

if(NOT MSVC)
    add_definitions(-DqDNGThreadSafe=1)
endif()

# Level of debug info in the console.

add_definitions(-DqDNGDebug=0)
add_definitions(-DqDNGValidateTarget=1)

#---------------------------------

add_subdirectory(dimg)
add_subdirectory(dmetadata)
add_subdirectory(database)
add_subdirectory(dngwriter)
add_subdirectory(dtrash)
add_subdirectory(facesengine)
add_subdirectory(iojobs)
add_subdirectory(jpegutils)
add_subdirectory(pgfutils)
add_subdirectory(threadimageio)
add_subdirectory(widgets)
add_subdirectory(imageproperties)
add_subdirectory(progressmanager)
add_subdirectory(threads)
add_subdirectory(versionmanager)
add_subdirectory(notificationmanager)
add_subdirectory(models)
add_subdirectory(template)
add_subdirectory(dialogs)
add_subdirectory(kmemoryinfo)
add_subdirectory(fileactionmanager)
add_subdirectory(filters)
add_subdirectory(settings)
add_subdirectory(rawengine)
add_subdirectory(album)
add_subdirectory(tags)

=== core/showfoto/CMakeLists.txt ===
#
# Copyright (c) 2010-2016 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# Copyright (c) 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

if (POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif (POLICY CMP0063)

# We need to include the setup dir for showfoto BEFORE the other include dirs,
# otherwise the one from the "utilities" dir will be used
include_directories(BEFORE
                    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar
                    ${CMAKE_CURRENT_SOURCE_DIR}/setup
                    ${CMAKE_CURRENT_SOURCE_DIR}/main
)

include_directories(
    $<TARGET_PROPERTY:Qt5::Sql,INTERFACE_INCLUDE_DIRECTORIES>

    $<TARGET_PROPERTY:KF5::I18n,INTERFACE_INCLUDE_DIRECTORIES>

)

set(showfoto_SRCS
    setup/showfotosetuptooltip.cpp
    setup/showfotosetupmisc.cpp
    setup/showfotosetupmetadata.cpp
    setup/showfotosetupraw.cpp
    setup/showfotosetup.cpp

    thumbbar/showfotoiteminfo.cpp
    thumbbar/showfotoimagemodel.cpp
    thumbbar/showfotothumbnailmodel.cpp
    thumbbar/showfotofiltermodel.cpp
    thumbbar/showfotodragdrophandler.cpp
    thumbbar/showfotokineticscroller.cpp
    thumbbar/showfotoitemsortsettings.cpp
    thumbbar/showfotocoordinatesoverlay.cpp
    thumbbar/itemviewshowfotodelegate.cpp
    thumbbar/showfotodelegate.cpp
    thumbbar/showfototooltipfiller.cpp
    thumbbar/showfotocategorizedview.cpp
    thumbbar/showfotothumbnailbar.cpp

    main/showfotosettings.cpp
    main/main.cpp
    main/showfoto.cpp
)

file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/../data/icons/apps/*-apps-showfoto.png")
ecm_add_app_icon(showfoto_SRCS ICONS ${ICONS_SRCS})

add_executable(showfoto ${showfoto_SRCS}
                        $<TARGET_OBJECTS:setupshowfoto_src>
                        $<TARGET_OBJECTS:notificationmanager_src>
)

add_dependencies(showfoto digikam-gitversion)

# To fill plist XML file for OSX #####################################################

set(MACOSX_APP_NAME_STRING             "showfoto")
set(MACOSX_APP_DESCRIPTION             "Stand alone Photo Editor based on digiKam Image Editor")
set(MACOSX_BUNDLE_LONG_VERSION_STRING  ${DIGIKAM_VERSION_STRING})
set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${DIGIKAM_VERSION_SHORT})
set(MACOSX_BUNDLE_BUNDLE_VERSION       ${DIGIKAM_VERSION_STRING})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/templates/Info.plist.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
set_target_properties(showfoto PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)

target_link_libraries(showfoto
                      PRIVATE
                      digikamcore

                      libdng

                      Qt5::Core

                      KF5::I18n
                      KF5::XmlGui
)

if(KF5Notifications_FOUND)
    target_link_libraries(showfoto PUBLIC KF5::Notifications)
endif()

if(KF5NotifyConfig_FOUND)
    target_link_libraries(showfoto PUBLIC KF5::NotifyConfig)
endif()

if(NOT WIN32)
    # To link under Solaris (see bug #274484)
    target_link_libraries(showfoto PUBLIC ${MATH_LIBRARY})
endif()

if(CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
    target_link_libraries(showfoto PUBLIC ${KVM_LIBRARY})
endif()

install(TARGETS  showfoto                          ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS main/org.kde.showfoto.desktop     DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES    main/org.kde.showfoto.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
install(FILES    main/showfotoui5.rc               DESTINATION ${KXMLGUI_INSTALL_DIR}/showfoto)

=== doc/showfoto/CMakeLists.txt ===
#
# Copyright (c) 2010-2016, Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

KDOCTOOLS_CREATE_HANDBOOK(index.docbook INSTALL_DESTINATION ${HTML_INSTALL_DIR}/en SUBDIR showfoto)

=== po/cy/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( cy ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} PO_FILES ${_po_files} )

=== po/fr/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( fr ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} PO_FILES ${_po_files} )

=== po/hr/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( hr ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} PO_FILES ${_po_files} )

=== po/km/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( km ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} PO_FILES ${_po_files} )

=== po/ko/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( ko ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} PO_FILES ${_po_files} )

=== po/lo/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( lo ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} PO_FILES ${_po_files} )

=== debian/changelog ===
digikam (4:5.3.0-1) unstable; urgency=medium

  * New upstream.  Closes: #844126.
  - fixes encoded collection paths after upgrade from digikam v4.x.
    Closes: #834655.
  * digikam: add Depends on kipi-plugins.  Closes: #842112.
  * showfoto: strengthen dep on kipi-plugins from Recommends to Depends.
  * Build with ENABLE_KFILEMETADATASUPPORT=ON.
  * Build-Conflicts with libboost1.62-dev (<< 1.62.0+dfsg-4) because we
    need the degree-for-reverse_graph bug fix that is present in rev -4.

 -- Steve M. Robbins <smr@debian.org>  Sun, 13 Nov 2016 03:39:25 -0600

digikam (4:5.2.0-3) unstable; urgency=medium

  * Add build-dep on gphoto2.  Closes: #842094.
  * Build with -DENABLE_MEDIAPLAYER=ON.  Closes: #834131.
  * Build with -DENABLE_APPSTYLES=ON.  Closes: #842567.

 -- Steve M. Robbins <smr@debian.org>  Tue, 01 Nov 2016 01:06:53 -0500

digikam (4:5.2.0-2) unstable; urgency=medium

  * Add missing dependency for libqt5sql5-mysql.  Closes: #834365.
  * Rebuild will update libmarblewidget-qt5 dependency.  Closes: #840841,
    #841751.

 -- Steve M. Robbins <smr@debian.org>  Sun, 23 Oct 2016 11:39:28 -0500

digikam (4:5.2.0-1) unstable; urgency=medium

  [ Pino Toscano ]
  * Remove the alternative mplayerthumbs recommend, since it is dead and
    scheduled for removal from Debian.

  [ Steve Robbins ]
  * New upstream release (Closes: #838886).  Thanks to Norbert Preining
    for the patch.
  * patches/cmake-fix-doc-translated.patch: Remove; doc-translated no
    longer contains content.
  * patches/upstream-gcc6-fix.patch: Remove; applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Mon, 26 Sep 2016 00:08:15 -0500

digikam (4:5.1.0-2) unstable; urgency=medium

  * Team upload.
  * Replace the libgusb-dev build dependency with libusb-1.0-0-dev (but only
    for Linux).
  * Remove myself from Uploaders.
  * Switch from the specific libboost-graph1.60-dev to the default
    libboost-graph-dev. (Closes: #834175)
  * Enable again support for address book, adding the libkf5akonadicontact-dev
    build dependency.
  * Update watch file, letting it follow only stable versions.
  * Fix typo in copyright.

 -- Pino Toscano <pino@debian.org>  Sat, 13 Aug 2016 22:56:45 +0200

digikam (4:5.1.0-1) unstable; urgency=medium

  * New release.  Closes: #803456.
    - Add NEWS.Debian to describe configuration migration.
  * Update patches.
    - cmake-disable-doc-translated-showfoto.patch: Remove.
    - upstream-gcc6-fix.patch: New.  GCC 6.1/32bit fix from upstream git.
    - cmake-fix-doc-translated.patch: New.  Fix generation of translated docs.

 -- Steve M. Robbins <smr@debian.org>  Thu, 11 Aug 2016 00:42:31 -0500

digikam (4:5.0.0-1) experimental; urgency=medium

  * Staging the 5.0.0 release.
    - Updated all build-depends.
    - Remove obsolete cmake flags DIGIKAMSC_COMPILE_LIBKFACE, ENABLE_LCMS2,
      KDE4_BUILD_TESTS.

  * Update patches.
    - doc-linkage.patch: 
    - sendimages-icedove.diff: Remove.  Patched file no longer
      in sources.
    - mysql-global-conf.patch:
    - upstream_fix-compilation-with-Lensfun-0.3.2.patch: Remove.
      Applied upstream.
    - cmake-disable-jasper.patch: New.  Disable build-time probe
      for Jasper libraries.

 -- Steve M. Robbins <smr@debian.org>  Sun, 10 Jul 2016 11:04:43 -0500

=== debian/control ===
Source: digikam
Section: graphics
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>, Fathi Boudra <fabo@debian.org>, Steve M. Robbins <smr@debian.org>
Build-Depends: debhelper (>= 9), pkg-kde-tools (>= 0.15.21), pkg-config, help2man,
 cmake (>= 3.0.0),
 flex, bison,
 extra-cmake-modules (>= 1.7.0),
 qtbase5-dev (>= 5.4.0), qtbase5-dev-tools (>= 5.4.0),
 qtmultimedia5-dev,
 libkf5akonadicontact-dev,
 libkf5calendarcore-dev,
 libkf5filemetadata-dev,
 libkf5kipi-dev,
 libkf5notifications-dev,
 libkf5notifyconfig-dev,
 libqt5opengl5-dev,
 libkf5sane-dev,
 libkf5threadweaver-dev,
 libqt5svg5-dev,
 libqt5webkit5-dev,
 libqt5x11extras5-dev,
 libqt5xmlpatterns5-dev,
 libexiv2-dev,
 libjpeg-dev,
 libtiff-dev,
 libpng-dev, 
 liblcms2-dev,
 libboost-graph-dev,
 libexpat1-dev | libexpat-dev,
 libopencv-dev (>= 2.4.9),
 liblqr-1-0-dev,
 liblensfun-dev,
 libgphoto2-dev, gphoto2, libusb-1.0-0-dev [linux-any],
 libmarble-dev,
 libeigen3-dev (>= 3.1.2)
Build-Conflicts: libgraphicsmagick1-dev, libboost1.62-dev (<< 1.62.0+dfsg-4)
Standards-Version: 3.9.8
Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/digikam/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/digikam/trunk/
Homepage: http://www.digikam.org

Package: digikam-private-libs
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: private libraries for digiKam and kipi plugins
 This package contains private libraries to be used by digikam and
 kipi-plugins.
 .
 This has no use for anything else than digikam, since the libraries are
 installed in a private library path.

Package: digikam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, digikam-private-libs (= ${binary:Version}), libqt5sql5-sqlite, libqt5sql5-mysql, digikam-data (= ${source:Version}), kipi-plugins (= ${binary:Version})
Recommends: www-browser, ffmpegthumbs
Suggests: digikam-doc, systemsettings
Conflicts: ${digikam:Conflicts}
Description: digital photo management application for KDE
 Digital photo management program designed to import, organize, enhance, search
 and export your digital images to and from your computer.
 .
 It provides a simple interface which makes importing and organizing digital
 photographs a "snap". digiKam enables you to manage large numbers of
 digital photographs in albums and to organize these photographs for easy
 retrieval using tags (keywords), captions, collections, dates, geolocation
 and searches. It has many features for viewing, organizing, processing and
 sharing your images. Thus, digiKam is a formidable digital asset management
 (DAM) software including powerful image editing functions. 
 .
 An easy-to-use camera interface is provided, that will connect to your
 digital camera and download photographs directly into digiKam albums.
 More than 1000 digital cameras are supported by the gphoto2 library.
 Of course, any media or card reader supported by your operating system
 will interface with digiKam. 
 .
 digiKam incorporates a fast Image Editor with many image editing tools.
 You can use the Image Editor to view your photographs, comment and rate
 them, correct, enhance and alter them. The editing power can be easily
 extended by a set of plugins, the KDE Image Plugins Interface (manual) 
 .
 While digiKam remains easy to use, it provides professional level features
 by the dozens. It is fully 16 bit enabled including all available plugins,
 supports RAW format conversion through libraw, DNG export and ICC color
 management work flow. 
 .
 digiKam can also make use of the KIPI image handling plugins to
 extend its capabilities even further for photo manipulations,
 import and export, etc. The kipi-plugins package contains many
 very useful extensions.

Package: showfoto
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, digikam-private-libs (= ${binary:Version}), kipi-plugins (= ${binary:Version})
Recommends: dolphin
Breaks: digikam-doc (<< 2:2.0.0-1), kipi-plugins-common (<< 4:3.1.0-2~)
Replaces: digikam-doc (<< 2:2.0.0-1), kipi-plugins-common (<< 4:3.1.0-2~)
Description: image viewer/editor for KDE
 showFoto is the standalone image editor of the digiKam project.
 .
 It runs without digiKam images database support, but provides all Image Editor
 functions.

Package: digikam-data
Architecture: all
Depends: ${misc:Depends}, opencv-data
Breaks: kipi-plugins-common (<< 4:3.1.0-2~)
Replaces: kipi-plugins-common (<< 4:3.1.0-2~)
Conflicts: ${digikam:Conflicts}
Description: digiKam architecture-independant data
 Contains the significant amount of architecture-independent data that is
 shipped with digiKam.
 .
 It has been placed in an architecture all file to reduce space on the
 archives, rather than one copy for each architecture.

Package: digikam-doc
Architecture: all
Depends: ${misc:Depends}, khelpcenter4
Recommends: digikam
Section: doc
Description: handbook for digiKam 
 digiKam is an easy to use and powerful digital photo management
 application.
 .
 This package contains the handbooks for digiKam and kipi-plugins.

Package: kipi-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, kipi-plugins-common (= ${source:Version}),
 digikam-private-libs (= ${binary:Version})
Breaks: digikam (<< 4:2.3.0-2~), kipi-plugins-common (<< 4:3.1.0-2~)
Replaces: digikam (<< 4:2.3.0-2~), kipi-plugins-common (<< 4:3.1.0-2~)
Recommends: konqueror, imagemagick, hugin, enblend, enfuse, minidlna
Suggests: gimp, kmail, vorbis-tools
Enhances: digikam, gwenview, kphotoalbum, showimg
Description: image manipulation/handling plugins for KIPI aware programs
 KIPI plugins (KDE Image Plugin Interface) is an effort to develop a
 common plugin structure for digiKam, KPhotoAlbum (formerly known as
 KimDaBa), Showimg and Gwenview.
 Its aim is to share image plugins among graphic applications.

Package: kipi-plugins-common
Architecture: all
Depends: ${misc:Depends}
Breaks: digikam (<< 4:2.3.0-2~), digikam-data (<< 4:3.1.0-2~)
Replaces: digikam (<< 4:2.3.0-2~), digikam-data (<< 4:3.1.0-2~)
Conflicts: ${digikam:Conflicts}
Description: kipi-plugins architecture-independent data
 KIPI plugins (KDE Image Plugin Interface) is an effort to develop a
 common plugin structure for digiKam, KPhotoAlbum (formerly known as
 KimDaBa), Showimg and Gwenview.
 Its aim is to share image plugins among graphic applications.
 .
 The architecture independent data needed for the kipi-plugins package.

=== debian/rules ===
#!/usr/bin/make -f

PRIVATE_LIBDIR := /usr/lib/digikam
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

# The following was previously used when building with local libkipi, libkexiv2, and libkdcraw implementation
#CONFLICTS_SUBSTVAR := libkipi-data, libkexiv2-data, libkdcraw-data, libksane-data

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Augment path to find gphoto2-config; workaround for #826166
export PATH := $(PATH):/usr/lib/$(DEB_HOST_MULTIARCH)/libgphoto2-dev/bin

%:
	dh $@ --with kde --parallel 

override_dh_clean:
	rm -f core/data/about/js/bootstrap.min.js core/data/about/js/jquery.min.js
	dh_clean

override_dh_auto_configure:
	ln -s -n -f ../libkface15083 extra/libkface
	dh_auto_configure --buildsystem=kde -- \
	  -DCMAKE_INSTALL_RPATH="$(PRIVATE_LIBDIR)" \
	  -DDIGIKAMSC_COMPILE_DOC=on \
	  -DDIGIKAMSC_COMPILE_PO=on \
	  -DENABLE_MYSQLSUPPORT=ON \
	  -DENABLE_INTERNALMYSQL=ON \
	  -DENABLE_KFILEMETADATASUPPORT=ON \
	  -DENABLE_MEDIAPLAYER=ON \
	  -DENABLE_APPSTYLES=ON

#	help2man -n 'digital photo management application' --no-info obj-*/core/app/digikam > debian/man/digikam.1
#	help2man -n 'image viewer/editor' --no-info obj-*/core/showfoto/showfoto > debian/man/showfoto.1

override_dh_auto_install:
	dh_auto_install
	# remove development stuff: headers, cmake config files, pkg-config files, .so symlinks, static libs
	rm -rf --verbose debian/tmp/usr/include
	rm -rf --verbose debian/tmp/usr/share/kde4/apps/cmake
	rm -rf --verbose debian/tmp/usr/lib/cmake
	rm -rf --verbose debian/tmp/usr/lib/pkgconfig
	find debian/tmp/usr/lib -type l -name '*.so' -exec rm --verbose {} \;
	# remove potentially conflicting oxygen icons in global icon theme
	rm -rf --verbose debian/tmp/usr/share/icons/oxygen
	# remove libkipi translations, provided by kde-l10n-*
	rm -rf --verbose debian/tmp/usr/share/locale/*/LC_MESSAGES/libkipi.mo
	# remove haar cascades, the versions in opencv-data will be used instead
	rm -rf --verbose debian/tmp/usr/share/kde4/apps/libkface/haarcascades

override_dh_installchangelogs:
	dh_installchangelogs -pdigikam core/ChangeLog
	dh_installchangelogs -pkipi-plugins extra/kipi-plugins/ChangeLog
	dh_installchangelogs --remaining-packages

override_dh_install:
	dh_install --fail-missing
	# remove duplicate libkipiplugins copied also in digikam-private-libs
	rm -f --verbose debian/digikam-private-libs/$(PRIVATE_LIBDIR)/libkipiplugins.so.*

override_dh_shlibdeps:
	dh_shlibdeps -l$(CURDIR)/debian/digikam-private-libs/$(PRIVATE_LIBDIR):$(CURDIR)/debian/kipi-plugins/$(PRIVATE_LIBDIR)

override_dh_gencontrol:
	dh_gencontrol -- -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'

# auto tests require user interaction - override
override_dh_auto_test:
